package java.lang.instrument;

import java.util.jar.JarFile;

public interface Instrumentation
{
    public abstract void addTransformer(ClassFileTransformer p0, boolean p1);
    
    public abstract void addTransformer(ClassFileTransformer p0);
    
    public abstract boolean removeTransformer(ClassFileTransformer p0);
    
    public abstract boolean isRetransformClassesSupported();
    
    public abstract void retransformClasses(Class<?>... p0) throws UnmodifiableClassException;
    
    public abstract boolean isRedefineClassesSupported();
    
    public abstract void redefineClasses(ClassDefinition... p0) throws ClassNotFoundException, UnmodifiableClassException;
    
    public abstract boolean isModifiableClass(Class<?> p0);
    
    public abstract Class[] getAllLoadedClasses();
    
    public abstract Class[] getInitiatedClasses(ClassLoader p0);
    
    public abstract long getObjectSize(Object p0);
    
    public abstract void appendToBootstrapClassLoaderSearch(JarFile p0);
    
    public abstract void appendToSystemClassLoaderSearch(JarFile p0);
    
    public abstract boolean isNativeMethodPrefixSupported();
    
    public abstract void setNativeMethodPrefix(ClassFileTransformer p0, String p1);
}
